{ Intuition: ----------------------------------------------------- }

const jam1=0; jam2=1;

type koords =array[0..31] of integer;
     border =record
             x,y,fpen,bpen,drmode,ecken:integer;
             p_ecken                   :^koords;
             p_nextborder              :pointer;
             end;

     image  =record
             x,y         :integer;
             width,height:integer;
             p_data      :^byte;
             p_nextimage :pointer;
             end;

   intuitext=record
             x,y,fpen,bpen,drmode:integer;
             itext               :string;
             p_nexttext          :pointer;
             end;

  boolgadget=record
             id,x,y,width,height,bpen,hibpen:integer;
             p_loborder,p_hiborder          :pointer;
             p_loimage,p_hiimage            :pointer;
             p_lointuitext,p_hiintuitext    :pointer;
             onoff,active                   :boolean;
             p_nextgadget                   :pointer;
             end;

    p_border=^border;
    p_image =^image;
 p_intuitext=^intuitext;
    p_gadget=^boolgadget;





procedure rectfill(x1,y1,x2,y2,c:integer);
var i:integer;
begin  { patch fr BGI-Anweisung BAR }
   Setcolor(c);
   for i:=y1 to y2 do line(x1,i,x2,i);
end;


procedure drawborder(xx,yy:integer; ibord:p_border);
var i,j,x1,x2,y1,y2:integer;
begin
   with ibord^ do begin
     { if drmode=jam2 then begin
         x1:=xx+x; y1:=yy+y;
         rectfill(x1,y1,p_data,bpen);
       end; }
       j:=0;   x1:=p_ecken^[j]+xx;
       inc(j); y1:=p_ecken^[j]+yy;
       setcolor(fpen);
       for i:=2 to ecken do begin
          inc(j); x2:=p_ecken^[j]+xx;
          inc(j); y2:=p_ecken^[j]+yy;
          line(x1,y1,x2,y2);
          x1:=x2;
          y1:=y2;
       end;
       if p_nextborder<>nil then drawborder(xx,yy,p_nextborder);
    end;
end;


procedure DrawImage(xx,yy:integer; ima:p_image);
var x1,y1    :integer;
begin
   with ima^ do begin
      x1:=xx+x;
      y1:=yy+y;
      putimage(x1,y1,ima^.p_data^,normalput);
      if p_nextimage<>nil then drawimage(xx,yy,p_nextimage);
   end;
end;

procedure DrawIntuiText(xx,yy:integer; intext:p_IntuiText);
{ im Moment fixiert auf 8x8-Fonts }
var x1,y1,x2,y2:integer;
    nexttext   :intuitext;
begin
   with intext^ do begin
      x1:=xx+x;
      y1:=yy+y;
      if drmode=jam2 then begin
         x2:=pred(length(itext)*8+x1);
         y2:=y1+7;
         rectfill(x1,y1,x2,y2,bpen);
      end;
      setcolor(fpen);
      outtextxy(x1,y1,itext);
      if p_nexttext<>nil then drawintuitext(xx,yy,p_nexttext);
   end;
end;


procedure DrawGadget(igad:p_gadget);
var i,j,k,x1,x2,x3,x4,y1,y2,y3,y4:integer;
begin
   if igad^.active then with igad^ do begin
      x1:=pred(x+width);
      y1:=y+pred(height);
      if onoff then begin
         if hibpen>-1 then rectfill(x,y,x1,y1,hibpen);
         if p_hiimage<>nil then DrawImage(x,y,p_hiimage);
         if p_hiborder<>nil then DrawBorder(x,y,p_hiborder);
         if p_hiintuitext<>nil then DrawIntuiText(x,y,p_hiintuitext);
      end else begin
         if bpen>-1 then rectfill(x,y,x1,y1,bpen);
         if p_loimage<>nil then DrawImage(x,y,p_loimage);
         if p_loborder<>nil then DrawBorder(x,y,p_loborder);
         if p_lointuitext<>nil then DrawIntuiText(x,y,p_lointuitext);
      end;
   end;
{   if igad^.p_nextgadget<>nil then drawgadget(igad^.p_nextgad);
   end;  }
end;




          




{ ##### Uff, soweit so gut, Amigos! ################################## }
{ -------------------------------------------------------------------- }
