program mahjongg;
{ uja 0.98: 06.07.94   1. ruckelfreie Version, Alt, Neu, Quit, Zugrcknahme}
{                      Untertitel: K(r)ampf mit BGI, VGA und Cirrus-Pages  }
{ uja 0.99: 07.07.94   Einbinden neuer Levels ber Levelverweise ->files:  }
{                      Hilfsdatei mit Levelnamen, Leveldateien, bis 25     }
{                      Dragon, Castle, Tempel, Pyramide /' '=Screenrefresh }
{ uja 1.00: 10.07.94   Endbild, Bilder via Heap, redraw auf zmax optimiert }
{ uja 1.10: 18.08.95   Anzeige Restchips, mgliche Zge                    }
{ uja 2.00: 16.02.97   Umstellung auf neue Intuit, key-Handling            }

{$M 8192,0,65536 }
uses crt,dos,graph,drivers,intuit,timer;

const ox=20; oy=32; oxx=-4; oyy=-4; dx=16; dy=16; xmax=36; ymax=24; zmax=8;
      imafile  ='MahJongg.ima';
      levelfile='MahJongg.lev';
      end1file ='MahEnde1.ima';
      end2file ='MahEnde2.ima';

type feld=array[0..xmax,0..ymax,0..zmax] of byte;
     imabuff=array[0..32999] of byte;
     liste  =array[0..144] of record x,y,z:integer; code:byte; end;
     fliste =array[0..25] of record lname,filnam:string end;


var igad                  : array[1..9] of gadget;
    itext1,itext2         : array[1..8] of intuitext;
    ibord1,ibord2         : array[1..2] of border;
    ima                   : array[1..36] of image;
    xy1,xy2,xy3,xy4       : koords;
    bufptr,size           : word;
    ibuff                 : pointer;
    reserve,leer,ima0     : image;

    mx,my,ikey,code,nchip,nindex,x,y,z,x1,y1,z1,i,cx,cy: integer;
    ok,fertig,ende,hflag  : boolean;
    f                     : feld;
    clist,ctemp           : liste;
    flst                  : fliste;
    ch,ch1                : char;
    temp                  : string;
    b,select,k            : byte;


{$i mah2.inc }
{$i mah1.inc }
{$i mah3.inc }

procedure hilfe;
var i,j,k:integer; t:string;
begin
   rectfill(0,16,639,459,12);
   for i:=1 to 24 do begin
   case i of
   1: t:='Ziel des Spiels ist es, freie, gleiche Steine paarweise abzurumen.';
   2: t:='Ein Stein ist frei, wenn er sich nach links oder rechts verschieben lt,';
   3: t:='und wenn kein Stein direkt ber ihm liegt.';
   4: t:='';
   5: t:='Steuerung:';
   6: t:='1. Stein anklicken oder mit Cursor anwhlen, dann [Leertaste] drcken';
   7: t:='Der gewhlte Stein wird markiert. Danach den 2. Stein anwhlen.';
   8: t:='Sind die obigen Regeln erfllt, verschwinden beide Steine.';
   9: t:='';
   10: t:='Gadgets:   Tasten:';
   11: t:='[Chips   ]  [C]    zeigt restliche Chips an';
   12: t:='[Zge    ]  [Z]    zeigt mgliche Zge an, weiter mit [ ], Ende mit [Q]';
   13: t:='[Rckn.  ]  [R]    Zugrcknahme';
   14: t:='[Start   ]  [S]    aktuelles Spiel von vorne beginnen';
   15: t:='[Neu     ]  [N]    neues Spiel mit gleichem Muster beginnen';
   16: t:='[Feldname]  [F]    ein anderes Muster laden, Muster 1-nn aussuchen, in-';
   17: t:='                   dem man das entsprechende Feld anklickt oder die Ken-';
   18: t:='                   nung eingibt.';
   19: t:='[Ende    ]  [E]    Ende des Spiels';
   20: t:='';
   24: t:='                   zum Spiel: [Leertaste] oder hier klicken';
   end;
   setcolor(0);
   outtextxy(17,i*12+72,t);
   setcolor(1);
   outtextxy(16,i*12+72,t);
   end;
   j:=0;
   for i:=1 to 18 do begin
      j:=j+7;
      putimage(2*i*dx,32,ima[succ(j mod 36)].p_data^,normalput);
      putimage(2*i*dx,396,ima[succ((j+18) mod 36)].p_data^,normalput);
   end;
end;




begin
   ch:=#0;
   initscreen(ok);
   if ok then begin

      initstructures;
      cursorimage;
      zeichnescreen;
      refreshgadgets(addr(igad[1]));
      ladelevels(ok);
      initfeld;
      zeichnefeld;
      chipanzeige(nchip);

      initmouse;
      select:=0;
      ende:=false;
      initcursor(cx,cy);

      hflag:=false;
      repeat
         if not hflag then togglecursor(cx,cy);
         z:=-1;
         showmouse;
         delay1(100);
         if not hflag then togglecursor(cx,cy);
         getgadget(addr(igad[1]),z,mx,my);
         while keypressed do begin
            ch:=readkey;
            case ch of
            #0     : begin
                        ch1:=readkey;
                        case ch1 of
                        #72: k:=0; { Cursor up }
                        #75: k:=3;
                        #77: k:=1;
                        #80: k:=2;                   { down }
                        #59: z:=7;
                        end; { case }
                        keyintercept(cx,cy,k);
                        mx:=cx;
                        my:=cy;
                     end;
            #13,#32: z:=9;
            #27,'E','e','Q','q': z:=8;
            'C','c': z:=1;
            'F','f': z:=6;
            'H','h': z:=7;
            'N','n': z:=5;
            'R','r': z:=3;
            'S','s': z:=4;
            'Z','z': z:=2;
            end;
            ch:='.';
         end;
         hidemouse;
         if z>0 then begin
         if hflag then begin
            hflag:=false;
            zeichnefeld;
         end;
         case z of
         1: begin { showreste }
               showchips;
               zeichnefeld;
            end;
         2: begin { Dubletten zeigen }
               if select=0 then showrest else suchechip(x1,y1,z1);
            end;
         3: if nindex>0 then begin   { Zugrcknahme }
               with ctemp[nindex] do begin
                  f[x,y,z]:=code;
                  updatfeld(x,y,z);
               end;
               dec(nindex);
               with ctemp[nindex] do begin
                  f[x,y,z]:=code;
                  updatfeld(x,y,z);
               end;
               dec(nindex);
               nchip:=nchip+2;
               chipanzeige(nchip);
            end;
         4: begin    { Neustart }
               nindex:=0;
               for i:=1 to 144 do with clist[i] do f[x,y,z]:=code;
               nchip:=144;
               zeichnefeld;
               chipanzeige(nchip);
               select:=0;
            end;
         5: begin    { Neues Spiel, gleiches Pattern }
               nindex:=0;
               select:=0;
               mischen;
               for i:=1 to 144 do with clist[i] do f[x,y,z]:=code;
               nchip:=144;
               zeichnefeld;
               chipanzeige(nchip);
            end;
         6: begin
               getneupatt(temp);
               if length(temp)>0 then begin
                  ladepattern(temp,ok);
                  if not ok then begin
                     itext1[4].itext:='Intern';
                     itext2[4].itext:=itext1[4].itext;
                     DrawGadget(addr(igad[4]));
                     initfeld;
                  end;
               end;
               zeichnefeld;
               chipanzeige(nchip);
            end;

         7: begin
               hidemouse;
               hflag:=true;
               hilfe;
               showmouse;
            end;
         8: ende:=true;

         9: begin
            capture(mx,my,x,y,z,b);
            if b>0 then if frei(x,y,z) then begin
               if select>0 then begin
                  if (x<>x1) or (y<>y1) or (z<>z1) then begin
                     if select=b then begin
                        nchip:=nchip-2;
                        chipanzeige(nchip);
                        inc(nindex);                 { fr Zugrcknahme }
                        ctemp[nindex].x:=x;
                        ctemp[nindex].y:=y;
                        ctemp[nindex].z:=z;
                        ctemp[nindex].code:=b;
                        inc(nindex);
                        ctemp[nindex].x:=x1;
                        ctemp[nindex].y:=y1;
                        ctemp[nindex].z:=z1;
                        ctemp[nindex].code:=b;
                        f[x,y,z]:=0;
                        f[x1,y1,z1]:=0;
                        updatfeld(x,y,z);
                        updatfeld(x1,y1,z1);
                     end else updatfeld(x1,y1,z1);
                     select:=0;
                  end;
               end else begin
                  x1:=x; y1:=y; z1:=z;
                  hilite(x,y,z);
                  select:=b;
               end;
           if nchip=0 then begin
              endbild;
              ikey:=0;
           end;
           end;
           end;
         end;
         end;
      until ende;
      hidemouse;
      textmode(3);
   end;
end.


